package cn.com.taiji.esshipservice.config;

import io.daas.bingocloud.client.DaasioClient;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.annotation.Resource;

/**
 * @author zzyx 2021/9/6/006
 */
@Configuration
public class DassIoClientConfig {

    @Resource
    private BingoFileConfig fileConfig;

    @Bean
    public DaasioClient daasioClient() {
        boolean isHttps = "1".equals(fileConfig.getHttpsOnly());
        DaasioClient daasioClient = DaasioClient.builder().
                endPoint(fileConfig.getIp(), fileConfig.getPort(), isHttps).
                accessKey(fileConfig.getAccessKey()).
                secretKey(fileConfig.getSecretKey()).
                region("us-west-1").build();
        return daasioClient;
    }
}
