package cn.com.taiji.esshipservice.utils;

import com.bingocloud.services.s3.AmazonS3Client;
import com.bingocloud.services.s3.model.*;
import io.daas.bingocloud.client.DaasioClient;
import io.daas.bingocloud.store.MinioFileSystem;
import lombok.Synchronized;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import javax.net.ssl.*;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.List;
import java.util.UUID;

@Slf4j
@Component
public class HttpsDownloadUtils extends MinioFileSystem{

    @Resource
    public DaasioClient daasioClient;

    static final String preFix  = "ax_es_hik_images";

    static final String postFix = ".jpg";

    static final String httpUrl = "http://74.10.28.62:81/ax_es_hik_images/";

    static String url = "https://gimg2.baidu.com/image_search/src=http%3A%2F%2Fstatic.aryee.cn%2Fuploads%2F20200510%2F1b158e9b3962608c332d944b214ac6bc.jpg&refer=http%3A%2F%2Fstatic.aryee.cn&app=2002&size=f9999,10000&q=a80&n=0&g=0n&fmt=auto?sec=1651926867&t=65e95bd1e0754ce1d343b893e3fd2a36";

    /**
     * @param fileUrl   https 远程路径
     * @throws Exception
     */
    public synchronized String downloadCarFileHttps(String fileUrl) {
        try{
            SSLContext sslcontext = SSLContext.getInstance("SSL", "SunJSSE");
            sslcontext.init(null, new TrustManager[]{new X509TrustUtiil()}, new java.security.SecureRandom());
            URL url = new URL(fileUrl);
            HttpsURLConnection.setDefaultHostnameVerifier((urlHostName, session) -> true);
            HttpsURLConnection.setDefaultSSLSocketFactory(sslcontext.getSocketFactory());
            HttpsURLConnection connection = (HttpsURLConnection) url.openConnection();
            connection.setConnectTimeout(6000);
            connection.setReadTimeout(6000);
            connection.setRequestProperty("Content-Type", "image/jpeg");
            int code = connection.getResponseCode();
            if (code == HttpURLConnection.HTTP_OK) {
                InputStream inputStream = connection.getInputStream();
                AmazonS3Client amazonS3Client = getAmazonS3Client(daasioClient);
                List<Bucket> buckets = amazonS3Client.listBuckets();
                String key = UUID.randomUUID().toString();
                PutObjectResult putObjectResult = amazonS3Client.putObject(new PutObjectRequest(buckets.get(2).getName(), preFix + key + postFix, inputStream, new ObjectMetadata()));
                copyAclFromParent(buckets.get(2).getName(),preFix + key + postFix);
                amazonS3Client.shutdown();
                String data = httpUrl + preFix + key +postFix;
                return data;
            }else {
//                throw new RuntimeException("文件读取失败");
                log.info("文件读取失败");
                return null;
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }


    /**
     * @param fileUrl   https 远程路径
     * @throws Exception
     */
    public synchronized String downloadFaceFileHttps(String fileUrl) {
        try{
            SSLContext sslcontext = SSLContext.getInstance("SSL", "SunJSSE");
            sslcontext.init(null, new TrustManager[]{new X509TrustUtiil()}, new java.security.SecureRandom());
            URL url = new URL(fileUrl);
            HttpsURLConnection.setDefaultHostnameVerifier((urlHostName, session) -> true);
            HttpsURLConnection.setDefaultSSLSocketFactory(sslcontext.getSocketFactory());
            HttpsURLConnection connection = (HttpsURLConnection) url.openConnection();
            connection.setConnectTimeout(6000);
            connection.setReadTimeout(6000);
            connection.setRequestProperty("Content-Type", "image/jpeg");
            int code = connection.getResponseCode();
            if (code == HttpURLConnection.HTTP_OK) {
                InputStream inputStream = connection.getInputStream();
                AmazonS3Client amazonS3Client = getAmazonS3Client(daasioClient);
                List<Bucket> buckets = amazonS3Client.listBuckets();
                String key = UUID.randomUUID().toString();
                PutObjectResult putObjectResult = amazonS3Client.putObject(new PutObjectRequest(buckets.get(2).getName(), preFix + key + postFix, inputStream, new ObjectMetadata()));
                copyAclFromParent(buckets.get(2).getName(),preFix + key + postFix);
                amazonS3Client.shutdown();
                String data = httpUrl + preFix + key +postFix;
                return data;
            }else {
//                throw new RuntimeException("文件读取失败");
                log.info("文件读取失败");
                return null;
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    /**
     * @param fileUrl   https 远程路径
     * @throws Exception
     */
    public String downloadFileHttp(String fileUrl) {
        String key = "";
        String data = "";
        AmazonS3Client amazonS3Client = null;
        try{
            SSLContext sslcontext = SSLContext.getInstance("SSL", "SunJSSE");
            sslcontext.init(null, new TrustManager[]{new X509TrustUtiil()}, new java.security.SecureRandom());
            URL url = new URL(fileUrl);
            HostnameVerifier ignoreHostnameVerifier = new HostnameVerifier() {
                @Override
                public boolean verify(String s, SSLSession sslsession) {
                    //log.warn("Hostname is not matched for cert.");
                    return true;
                }
            };
            HttpURLConnection connection = (HttpURLConnection) url.openConnection();
            connection.setConnectTimeout(6000);
            connection.setReadTimeout(6000);
            int code = connection.getResponseCode();
            if (code == HttpURLConnection.HTTP_OK) {
                InputStream inputStream = connection.getInputStream();
                amazonS3Client = getAmazonS3Client(daasioClient);
                List<Bucket> buckets = amazonS3Client.listBuckets();
                key = UUID.randomUUID().toString();
                PutObjectResult putObjectResult = amazonS3Client.putObject(new PutObjectRequest(buckets.get(0).getName(), preFix + key + postFix, inputStream, new ObjectMetadata()));
                copyAclFromParent(buckets.get(0).getName(),preFix + key + postFix);
                data = httpUrl + preFix + key +postFix;
                return data;
            }else {
                throw new RuntimeException("文件读取失败");
            }
        }catch (Exception e){
            e.printStackTrace();
        }finally {
            amazonS3Client.shutdown();
        }
        return null;
    }

    /**
     * X509Trust
     */
    static class X509TrustUtiil implements X509TrustManager {

        @Override
        public void checkClientTrusted(X509Certificate[] x509Certificates, String s) throws CertificateException {

        }

        @Override
        public void checkServerTrusted(X509Certificate[] x509Certificates, String s) throws CertificateException {

        }

        @Override
        public X509Certificate[] getAcceptedIssuers() {
            return null;
        }

    }

    //拷贝权限
    private void copyAclFromParent(String target,String objectTagName) {
        String bucketName = getBucketName(target);
        String targetObjectName = objectTagName;
        AmazonS3Client amazonS3Client = getAmazonS3Client(daasioClient);
        AccessControlList parentAcl;
        parentAcl = amazonS3Client.getBucketAcl(bucketName);
        amazonS3Client.setObjectAcl(bucketName, targetObjectName, parentAcl);
        amazonS3Client.shutdown();
    }

    //获取客户端
    private AmazonS3Client getAmazonS3Client(DaasioClient daasioClient) {
        com.bingocloud.auth.BasicAWSCredentials cred = new com.bingocloud.auth.BasicAWSCredentials(daasioClient.accessKey(), daasioClient.secretKey());
        AmazonS3Client client = new AmazonS3Client(cred);
        client.setEndpoint(daasioClient.endPoint());
        return client;
    }
}

