package cn.com.taiji.esshipservice.utils;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.io.IOException;
import java.io.InputStream;

public class JsonParser {

    // 线程安全的，可以采用全局共享
    private static volatile ObjectMapper objectMapper = null;

    public static String toJson(Object object) {
        try {
            return objectMapper().writeValueAsString(object);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        return "";
    }

    public static String toJson(InputStream inputStream) {
        try {
            return objectMapper().writeValueAsString(inputStream);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        return "";
    }

    public static <T> T toObject(InputStream inputStream, Class<T> cls) {
        try {
            return objectMapper().readValue(inputStream, cls);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    public static <T> T toObject(String json, Class<T> cls) {
        try {
            return objectMapper().readValue(json, cls);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    public static JSONObject toJSONObject(String json,Class<JSONObject> cls) {
        try {
            return objectMapper().readValue(json,cls);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    public static JSONArray toJSONArray(String json,Class<JSONArray> cls) {
        try {
            return objectMapper().readValue(json,cls);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    public static <T> T toObject(byte[] json, Class<T> cls) {
        try {
            return objectMapper().readValue(json, cls);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    public static ObjectMapper objectMapper(){
        if (null == objectMapper) {
            objectMapper = new ObjectMapper();
            objectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
        }
        return objectMapper;
    }

}

